package com.github.wxiaoqi.security.common.util;

import java.util.*;

/**
 * Created by ace on 2017/9/27.
 */
public class UUIDUtils {
    public static String[] chars = new String[] { "a", "b", "c", "d", "e", "f",
            "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s",
            "t", "u", "v", "w", "x", "y", "z", "0", "1", "2", "3", "4", "5",
            "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I",
            "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V",
            "W", "X", "Y", "Z" };


    public static String[] chars1 = new String[] { "a", "b", "c", "d", "e", "f",
            "g", "h", "i", "j", "k", "l", "m", "n", "p", "q", "r", "s",
            "t", "u", "v", "w", "x", "y", "z", "1", "2", "3", "4", "5",
            "6", "7", "8", "9", "A", "B", "C", "D", "E", "F", "G", "H", "I",
            "J", "K", "L", "M", "N",  "P", "Q", "R", "S", "T", "U", "V",
            "W", "X", "Y", "Z" };

    public static String generateShortUuid() {
        StringBuffer shortBuffer = new StringBuffer();
        String uuid = UUID.randomUUID().toString().replace("-", "");
        for (int i = 0; i < 8; i++) {
            String str = uuid.substring(i * 4, i * 4 + 4);
            int x = Integer.parseInt(str, 16);
            shortBuffer.append(chars[x % 0x3E]);
        }
        return shortBuffer.toString();

    }
    public static String genCodes(int length) {
        StringBuffer shortBuffer = new StringBuffer();
        String uuid = UUID.randomUUID().toString().replace("-", "");
        //System.out.println(uuid);
        for (int i = 0; i < length; i++) {
            String str = uuid.substring(i * 4, i * 4 + 4);
            int x = Integer.parseInt(str, 16);
//            chars1[x % 0x3B]chars[x % 0x3E]
            shortBuffer.append(chars1[x % 0x3B]);
        }
        return shortBuffer.toString();
    }


    public static void main(String[] args) {
        Map<String, Integer> map = new HashMap<String, Integer>();
        for(int i = 0; i < 100000000; i++) {
            //System.out.println(UUIDUtils.genCodes(6));
            String key = UUIDUtils.genCodes(8);
            if(null == map.get(key)) {
                map.put(key, 1);
            }else {
                System.out.println("重复"+ key+ ":"+ i);
                map.put(key, map.get(key) + 1);
            }
        }

        int flag = 0;
        Set<Map.Entry<String, Integer>> list = map.entrySet();
        for(Map.Entry<String, Integer> e : list) {
            if(e.getValue() > 1) {
                flag++;
                System.out.println(e.getKey()+ ":"+ e.getValue());
            }
        }
        System.out.println("flag : "+ flag);
    }


}
